/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.util;

import java.util.ArrayList;

public class SequencialList {
    private static final int NODE_SIZE = 1024;
    private static final int NODE_SHIFT = 10;
    private static final int NODE_OFFSET = 1023;
    private int size;
    private Object[] firstNode;
    private Object[] lastNode;
    private Object[] cacheNode;
    private int cachePage;

    public SequencialList() {
        this.clear();
    }

    public void clear() {
        this.size = 0;
        while (this.firstNode != null) {
            this.lastNode = (Object[])this.firstNode[1024];
            this.firstNode[1024] = null;
            this.firstNode = this.lastNode;
        }
        this.lastNode = null;
        this.cacheNode = null;
    }

    public void add(Object value) {
        int offset = this.size & 0x3FF;
        if (offset == 0) {
            Object[] newNode = new Object[1025];
            if (this.lastNode != null) {
                this.lastNode[1024] = newNode;
                this.lastNode = newNode;
            } else {
                this.firstNode = newNode;
                this.lastNode = newNode;
            }
        }
        this.lastNode[offset] = value;
        ++this.size;
    }

    public int size() {
        return this.size;
    }

    public Object get(int index) {
        if (index < 0 || index >= this.size) {
            return null;
        }
        if (this.cacheNode != null) {
            int page = index >> 10;
            if (page == this.cachePage) {
                return this.cacheNode[index &= 0x3FF];
            }
            if (page > this.cachePage) {
                index -= this.cachePage << 10;
            } else {
                this.cachePage = 0;
                this.cacheNode = this.firstNode;
            }
        } else {
            this.cachePage = 0;
            this.cacheNode = this.firstNode;
        }
        while (index >= 1024) {
            index -= 1024;
            this.cacheNode = (Object[])this.cacheNode[1024];
            ++this.cachePage;
        }
        return this.cacheNode[index];
    }

    public void set(int index, Object value) {
        if (index < 0 || index >= this.size) {
            return;
        }
        if (this.cacheNode != null) {
            int page = index >> 10;
            if (page == this.cachePage) {
                this.cacheNode[index &= 0x3FF] = value;
                return;
            }
            if (page > this.cachePage) {
                index -= this.cachePage << 10;
            } else {
                this.cachePage = 0;
                this.cacheNode = this.firstNode;
            }
        } else {
            this.cachePage = 0;
            this.cacheNode = this.firstNode;
        }
        while (index >= 1024) {
            index -= 1024;
            this.cacheNode = (Object[])this.cacheNode[1024];
            ++this.cachePage;
        }
        this.cacheNode[index] = value;
    }

    public int indexOf(Object data) {
        int result = 0;
        if (data != null) {
            Object[] node = this.firstNode;
            while (result < this.size) {
                int count = this.size - result >= 1024 ? 1024 : this.size - result;
                int i = 0;
                while (i < count) {
                    if (data.equals(node[i])) {
                        return result + i;
                    }
                    ++i;
                }
                result += 1024;
                node = (Object[])node[1024];
            }
        } else {
            Object[] node = this.firstNode;
            while (result < this.size) {
                int count = this.size - result >= 1024 ? 1024 : this.size - result;
                int i = 0;
                while (i < count) {
                    if (node[i] == null) {
                        return result + i;
                    }
                    ++i;
                }
                result += 1024;
                node = (Object[])node[1024];
            }
        }
        return -1;
    }

    public int remove(Object data) {
        int index = this.indexOf(data);
        if (index >= 0) {
            this.remove(index);
        }
        return index;
    }

    public Object remove(int index) {
        if (index < 0 || index >= this.size) {
            return null;
        }
        int tailCount = this.size - index - 1;
        if (this.cacheNode != null) {
            int page = index >> 10;
            if (page == this.cachePage) {
                index &= 0x3FF;
            } else if (page > this.cachePage) {
                index -= this.cachePage << 10;
            } else {
                this.cachePage = 0;
                this.cacheNode = this.firstNode;
            }
        } else {
            this.cachePage = 0;
            this.cacheNode = this.firstNode;
        }
        while (index >= 1024) {
            index -= 1024;
            this.cacheNode = (Object[])this.cacheNode[1024];
            ++this.cachePage;
        }
        Object result = this.cacheNode[index];
        Object[] node = this.cacheNode;
        while (tailCount > 0) {
            int count = index + tailCount;
            if (count > 1024) {
                count = 1024;
            }
            int i = index;
            while (i < count) {
                node[i] = node[i + 1];
                ++i;
            }
            if ((tailCount = tailCount - count + index) <= 0) continue;
            index = 0;
            Object[] nextNode = (Object[])node[1024];
            node[1023] = nextNode[0];
            node = nextNode;
        }
        --this.size;
        if ((this.size & 0x3FF) == 0) {
            this.lastNode = node;
            node[1024] = null;
        }
        return result;
    }

    public ArrayList toArrayList() {
        ArrayList<Object> result = new ArrayList<Object>(this.size);
        int i = 0;
        while (i < this.size) {
            result.add(this.get(i));
            ++i;
        }
        return result;
    }

    public static void test1() {
        int i;
        int count = 1000000;
        ArrayList<Integer> list1 = new ArrayList<Integer>();
        SequencialList list2 = new SequencialList();
        long curTime = System.currentTimeMillis();
        int i2 = 0;
        while (i2 < count) {
            list1.add(new Integer(i2));
            ++i2;
        }
        System.out.print("ArrayList Create: ");
        System.out.println(System.currentTimeMillis() - curTime);
        curTime = System.currentTimeMillis();
        i2 = 0;
        while (i2 < count) {
            list2.add(new Integer(i2));
            ++i2;
        }
        System.out.print("SequencialList Create: ");
        System.out.println(System.currentTimeMillis() - curTime);
        curTime = System.currentTimeMillis();
        int k = 0;
        while (k < 10) {
            i = 0;
            while (i < count) {
                if ((Integer)list1.get(i) != i) {
                    System.out.println("Error");
                }
                ++i;
            }
            ++k;
        }
        System.out.print("ArrayList Get: ");
        System.out.println(System.currentTimeMillis() - curTime);
        curTime = System.currentTimeMillis();
        k = 0;
        while (k < 10) {
            i = 0;
            while (i < count) {
                if ((Integer)list2.get(i) != i) {
                    System.out.println("Error");
                }
                ++i;
            }
            ++k;
        }
        System.out.print("SequencialList Get: ");
        System.out.println(System.currentTimeMillis() - curTime);
        curTime = System.currentTimeMillis();
        i2 = 0;
        while (i2 < count) {
            if (list1.indexOf(list1.get(i2)) != i2) {
                System.out.println("Error");
            }
            i2 += 3000;
        }
        System.out.print("ArrayList indexOf: ");
        System.out.println(System.currentTimeMillis() - curTime);
        curTime = System.currentTimeMillis();
        i2 = 0;
        while (i2 < count) {
            if (list2.indexOf(list2.get(i2)) != i2) {
                System.out.println("Error");
            }
            i2 += 3000;
        }
        System.out.print("SequencialList indexOf: ");
        System.out.println(System.currentTimeMillis() - curTime);
        curTime = System.currentTimeMillis();
        i2 = 0;
        while (i2 < count) {
            list1.remove(i2);
            i2 += 1000;
        }
        System.out.print("ArrayList remove: ");
        System.out.println(System.currentTimeMillis() - curTime);
        curTime = System.currentTimeMillis();
        i2 = 0;
        while (i2 < count) {
            list2.remove(i2);
            i2 += 1000;
        }
        System.out.print("SequencialList remove: ");
        System.out.println(System.currentTimeMillis() - curTime);
    }

    public static void test2() {
        SequencialList list = new SequencialList();
        int i = 0;
        while (i < 4000) {
            list.add(String.valueOf(i));
            ++i;
        }
        i = 0;
        while (i < 4000) {
            list.get(i);
            ++i;
        }
        i = 0;
        while (i < 4000) {
            list.set(i * 2, null);
            ++i;
        }
        i = 400;
        while (i < 4000) {
            System.out.println(list.get(i));
            ++i;
        }
    }

    public static void main(String[] args) {
        SequencialList.test1();
    }
}

